##############################################################################
##
## ***************************************************************************
## **                                                                       **
## ** Copyright (c) 1995-2006 Xilinx, Inc.  All rights reserved.            **
## **                                                                       **
## ** You may copy and modify these files for your own internal use solely  **
## ** with Xilinx programmable logic devices and Xilinx EDK system or       **
## ** create IP modules solely for Xilinx programmable logic devices and    **
## ** Xilinx EDK system. No rights are granted to distribute any files      **
## ** unless they are distributed in Xilinx programmable logic devices.     **
## **                                                                       **
## ***************************************************************************
##
## Modified:
## June 20 2006: Added html elaboration step
##############################################################################

proc generate {drv_handle} {
    puts "Generating Macros for ofdm_txrx_supermimo_plbw driver access ... "

    # initialize
    lappend config_table
    lappend addr_config_table
    lappend xparam_config_table

    # hardware version
    lappend config_table "C_XC_VERSION"
    # Low-level function names
    lappend config_table "C_XC_CREATE" "C_XC_RELEASE" "C_XC_OPEN" "C_XC_CLOSE" "C_XC_READ" "C_XC_WRITE" "C_XC_GET_SHMEM"
    # Optional parameters
    # (empty)

    # Memory map information
    sg_lappend config_table addr_config_table "C_MEMMAP_RX_BER_ERRORS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_BER_ERRORS_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_BER_ERRORS_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_BER_ERRORS_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_BER_TOTALBITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_BER_TOTALBITS_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_BER_TOTALBITS_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_BER_TOTALBITS_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_CONTROLBITS_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_CONTROLBITS_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_CONTROLBITS_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_CONTROLBITS_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_GAINS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_GAINS_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_GAINS_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_GAINS_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_OFDM_SYMBOLCOUNTS_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_OFDM_SYMBOLCOUNTS_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_OFDM_SYMBOLCOUNTS_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_OFDM_SYMBOLCOUNTS_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_PKTDET_DELAY_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDET_DELAY_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDET_DELAY_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDET_DELAY_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_PKTDET_LONGCORR_PARAMS_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDET_LONGCORR_PARAMS_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDET_LONGCORR_PARAMS_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDET_LONGCORR_PARAMS_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_PKTBYTENUMS_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTBYTENUMS_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTBYTENUMS_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTBYTENUMS_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_PKTDONE_INTERRUPTSTATUS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDONE_INTERRUPTSTATUS_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDONE_INTERRUPTSTATUS_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDONE_INTERRUPTSTATUS_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION0_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION0_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION0_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION0_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION1_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION1_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION1_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION1_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION2_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION2_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION2_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION2_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION3_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION3_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION3_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION3_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION4_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION4_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION4_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION4_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION5_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION5_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION5_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION5_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH0_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH0_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH0_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH0_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH1_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH1_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH1_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH1_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH2_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH2_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH2_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH2_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH3_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH3_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH3_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH3_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH4_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH4_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH4_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH4_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH5_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH5_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH5_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH5_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH6_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH6_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH6_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH6_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH7_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH7_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH7_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH7_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_INTERRUPT_PKTBUF_CTRL_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_INTERRUPT_PKTBUF_CTRL_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_INTERRUPT_PKTBUF_CTRL_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_INTERRUPT_PKTBUF_CTRL_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TX_CONTROLBITS_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_CONTROLBITS_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_CONTROLBITS_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TX_CONTROLBITS_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TX_OFDM_SYMCOUNTS_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_OFDM_SYMCOUNTS_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_OFDM_SYMCOUNTS_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TX_OFDM_SYMCOUNTS_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TX_PKTRUNNING"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_PKTRUNNING_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_PKTRUNNING_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TX_PKTRUNNING_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TX_START_RESET_CONTROL_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_START_RESET_CONTROL_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_START_RESET_CONTROL_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TX_START_RESET_CONTROL_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_MIDPACKETRSSI"
    sg_lappend config_table xparam_config_table "C_MEMMAP_MIDPACKETRSSI_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_MIDPACKETRSSI_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_MIDPACKETRSSI_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_PKTDET_CONTROLBITS_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_CONTROLBITS_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_CONTROLBITS_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_CONTROLBITS_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_PKTDET_DURATIONS_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_DURATIONS_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_DURATIONS_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_DURATIONS_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_PKTDET_STATUS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_STATUS_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_STATUS_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_STATUS_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_PKTDET_THRESHOLDS_R"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_THRESHOLDS_R_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_THRESHOLDS_R_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_THRESHOLDS_R_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_AF_TXSCALING_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_AF_TXSCALING_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_AF_TXSCALING_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_AF_TXSCALING_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_CONSTELLATION_SCALING_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_CONSTELLATION_SCALING_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_CONSTELLATION_SCALING_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_CONSTELLATION_SCALING_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_CONTROLBITS_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_CONTROLBITS_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_CONTROLBITS_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_CONTROLBITS_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_FREQOFFFILT_B_KI_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_FREQOFFFILT_B_KI_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_FREQOFFFILT_B_KI_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_FREQOFFFILT_B_KI_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_FREQOFFFILT_B_KP_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_FREQOFFFILT_B_KP_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_FREQOFFFILT_B_KP_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_FREQOFFFILT_B_KP_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_MINREQPILOTCHANMAG_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_MINREQPILOTCHANMAG_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_MINREQPILOTCHANMAG_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_MINREQPILOTCHANMAG_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_OFDM_SYMBOLCOUNTS_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_OFDM_SYMBOLCOUNTS_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_OFDM_SYMBOLCOUNTS_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_OFDM_SYMBOLCOUNTS_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_PHASENOISETRACK_K_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PHASENOISETRACK_K_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PHASENOISETRACK_K_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PHASENOISETRACK_K_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_PKTDET_DELAY_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDET_DELAY_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDET_DELAY_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDET_DELAY_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_PKTDET_LONGCORR_PARAMS_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDET_LONGCORR_PARAMS_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDET_LONGCORR_PARAMS_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDET_LONGCORR_PARAMS_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_PRECFO_OPTIONS_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PRECFO_OPTIONS_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PRECFO_OPTIONS_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PRECFO_OPTIONS_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_PKTBYTENUMS_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTBYTENUMS_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTBYTENUMS_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTBYTENUMS_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RX_PKTDET_TRESHOLDS_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDET_TRESHOLDS_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDET_TRESHOLDS_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RX_PKTDET_TRESHOLDS_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION0_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION0_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION0_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION0_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION1_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION1_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION1_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION1_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION2_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION2_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION2_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION2_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION3_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION3_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION3_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION3_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION4_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION4_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION4_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION4_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION5_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION5_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION5_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_ACTION5_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH0_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH0_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH0_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH0_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH1_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH1_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH1_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH1_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH2_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH2_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH2_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH2_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH3_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH3_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH3_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH3_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH4_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH4_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH4_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH4_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH5_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH5_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH5_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH5_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH6_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH6_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH6_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH6_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH7_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH7_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH7_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_AUTOREPLY_MATCH7_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_FFT_SCALING_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_FFT_SCALING_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_FFT_SCALING_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_FFT_SCALING_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_INTERRUPT_PKTBUF_CTRL_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_INTERRUPT_PKTBUF_CTRL_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_INTERRUPT_PKTBUF_CTRL_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_INTERRUPT_PKTBUF_CTRL_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_PILOTS_INDEX_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_PILOTS_INDEX_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_PILOTS_INDEX_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_PILOTS_INDEX_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXRX_PILOTS_VALUES_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_PILOTS_VALUES_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_PILOTS_VALUES_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXRX_PILOTS_VALUES_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TX_CONTROLBITS_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_CONTROLBITS_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_CONTROLBITS_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TX_CONTROLBITS_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TX_OFDM_SYMCOUNTS_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_OFDM_SYMCOUNTS_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_OFDM_SYMCOUNTS_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TX_OFDM_SYMCOUNTS_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TX_PREAMBLEMASKING_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_PREAMBLEMASKING_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_PREAMBLEMASKING_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TX_PREAMBLEMASKING_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TX_SCALING_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_SCALING_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_SCALING_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TX_SCALING_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TX_START_RESET_CONTROL_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_START_RESET_CONTROL_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TX_START_RESET_CONTROL_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TX_START_RESET_CONTROL_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_PKTDET_CONTROLBITS_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_CONTROLBITS_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_CONTROLBITS_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_CONTROLBITS_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_PKTDET_DURATIONS_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_DURATIONS_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_DURATIONS_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_DURATIONS_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_PKTDET_THRESHOLDS_W"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_THRESHOLDS_W_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_THRESHOLDS_W_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_PKTDET_THRESHOLDS_W_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_CHANNELESTIMATES"
    # sg_lappend config_table addr_config_table "C_MEMMAP_CHANNELESTIMATES_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_CHANNELESTIMATES_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_CHANNELESTIMATES_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_CHANNELESTIMATES_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_CHANNELESTIMATES_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_CHANNELESTIMATES_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_RXMODULATION"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RXMODULATION_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RXMODULATION_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RXMODULATION_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RXMODULATION_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RXMODULATION_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RXMODULATION_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXHEADERTRANSLATE"
    # sg_lappend config_table addr_config_table "C_MEMMAP_TXHEADERTRANSLATE_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_TXHEADERTRANSLATE_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXHEADERTRANSLATE_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXHEADERTRANSLATE_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXHEADERTRANSLATE_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXHEADERTRANSLATE_ATTR"

    sg_lappend config_table addr_config_table "C_MEMMAP_TXMODULATION"
    # sg_lappend config_table addr_config_table "C_MEMMAP_TXMODULATION_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_TXMODULATION_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXMODULATION_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXMODULATION_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXMODULATION_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXMODULATION_ATTR"

    # XPS parameters
    sg_lappend config_table xparam_config_table "DEVICE_ID" "C_BASEADDR"

    # generate xparameters.h
    eval xdefine_include_file $drv_handle "xparameters.h" "OFDM_TXRX_SUPERMIMO_PLBW" "NUM_INSTANCES" ${xparam_config_table}
    eval sg_xdefine_include_file $drv_handle "xparameters.h" "OFDM_TXRX_SUPERMIMO_PLBW" ${addr_config_table}
    # generate sg_plbiface_g.c
    eval xdefine_config_file $drv_handle "ofdm_txrx_supermimo_plbw_g.c" "OFDM_TXRX_SUPERMIMO_PLBW" ${config_table}
}

proc sg_xdefine_include_file {drv_handle file_name drv_string args} {
    # Open include file
    set file_handle [xopen_include_file $file_name]

    # Get all peripherals connected to this driver
    set periphs [xget_periphs $drv_handle] 

    # Print all parameters for all peripherals
    set device_id 0
    foreach periph $periphs {
        # base_addr of the peripheral
        set base_addr [xget_param_value $periph "C_BASEADDR"]

        puts $file_handle ""
        puts $file_handle "/* Definitions (address parameters) for peripheral [string toupper [xget_hw_name $periph]] */"
        foreach arg $args {
            set value [xget_param_value $periph $arg]
            if {[llength $value] == 0} {
                set value 0
            }
            set value [expr ${base_addr} + ${value}]
            set value [xformat_address_string $value]
            puts $file_handle "#define [xget_name $periph $arg] $value"
        }

        puts $file_handle "/* software driver settings for peripheral [string toupper [xget_hw_name $periph]] */"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_VERSION   1"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_CREATE    xc_ofdm_txrx_supermimo_plbw_create"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_RELEASE   xc_ofdm_txrx_supermimo_plbw_release"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_OPEN      xc_ofdm_txrx_supermimo_plbw_open"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_CLOSE     xc_ofdm_txrx_supermimo_plbw_close"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_READ      xc_ofdm_txrx_supermimo_plbw_read"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_WRITE     xc_ofdm_txrx_supermimo_plbw_write"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_GET_SHMEM xc_ofdm_txrx_supermimo_plbw_getshmem"

        puts $file_handle ""
    }		
    puts $file_handle "\n/******************************************************************/\n"
    close $file_handle
}

proc sg_lappend {required_config_table {extra_config_table ""} args} {
    upvar ${required_config_table} config_table_1
    if {[string length ${extra_config_table}] != 0} {
        upvar ${extra_config_table} config_table_2
    }

    foreach value ${args} {
        eval [list lappend config_table_1 ${value}]
        if {[string length ${extra_config_table}] != 0} {
            lappend config_table_2 ${value}
        }
    }
}
